menu menubar,status {
  -
  Server Port Scan:sportscan
}
alias sportscan { if ($dialog(sportscan) == $null) { dialog -m sportscan sportscan | spscan } | else halt }
alias servpto { if ($dialog(sportscan) != $null) { did -e sportscan 1 | .timer49 off | halt } }
alias spscan { did -b sportscan 1 | did -o sportscan 6 1 Scanning Ports... | .timer49 -o 1 3 servpto | did -r sportscan 4 | .enable #sps | stats l | halt }
dialog sportscan {
  title "Server Port Scan v2.0"
  option pixels 
  size -20 -20 220 330
  button "Refresh", 1, 153 40 50 20, ok
  list 4, 10 10 135 160,extsel,hsbar,sort
  edit "Server", 2, 10 255 195 20,autohs
  edit "Network", 20, 10 235 195 20,autohs
  edit "Status", 6, 10 275 195 20,autohs
  edit "", 8, 70 195 56 20,autohs
  text "Current", 9, 25 200 40 20
  text "Fastest", 15, 25 180 40 20
  button "Connect", 18, 153 10 50 20,disable
  button "Close", 17, 153 70 50 20, cancel
  edit "", 14, 70 175 56 20,autohs
  check "Start on Connect" 16, 10 300 100 30
  box "", 13, 10 160 135 65
  button "Connect", 19, 153 175 50 20,disable
}
on *:dialog:sportscan:init:*:{
  if ($server != $null) { did -f sportscan 1 }
  if ($dialog(sportscan) != $null) { did -m sportscan 6,2,20,14,8 }
  if ($dialog(sportscan) != $null) { if ($server == $null) { did -b sportscan 1 | did -b sportscan 4 | did -r sportscan 2 | did -r sportscan 8 | did -o sportscan 6 1 Not connected to server | did -b sportscan 1 | halt } }
  if ($dialog(sportscan) != $null) { did -o sportscan 2 1 $server | did -o sportscan 8 1 $port }
  if ($network != $null) { did -o sportscan 20 1 $upper($network) }
  if ($_vr(sportscan,connect) == on) did -c sportscan 16
  if ($dialog(sportscan) != $null) { did -z sportscan 4 }
  if ($did(sportscan,8).text != $null) { did -e sportscan 19 }
}
on *:dialog:sportscan:dclick:*:if ($did == 4) { quit Changing servers: $server $did(4,$did(4).sel) | server $server $+ : $+ $did(4,$did(4).sel) }
on *:dialog:sportscan:sclick:*:{
  if ($did == 1) { did -b sportscan 1 | did -o sportscan 6 1 $chr(160) $+ Scanning Ports... | .timer49 -o 1 3 servpto | did -r sportscan 4 | .enable #sps | stats l | halt }
  if ($did == 4) did -e sportscan 18 
  if ($did == 18) {
    if ($did(4,$did(4).sel) != $null) { did -o sportscan 6 1 Connecting to selected Port... | quit Changing servers: $server $did(4,$did(4).sel) | server $server $+ : $+ $did(4,$did(4).sel) }
    elseif ($did(4,$did(4).sel) == $null) { did -o sportscan 6 1 Please select a port | halt }
  }
  if ($did == 16) { 
    if ($_vr(sportscan,connect) == off) { _vw sportscan connect on | did -c sportscan 16 }
    else {  _vw sportscan connect off | did -u sportscan 16 }
  }
  if ($did == 19) { 
    if ($did(sportscan,8).text != $null) { if ($port != $did(sportscan,14).text) { quit Changing servers: $server $did(sportscan,14).text | server $server $+ : $+ $did(sportscan,14).text } }
    elseif ($did(sportscan,8).text != $null) { if ($port == $did(sportscan,14).text) { did -o sportscan 6 1 Already on this port. } }
  }
}
#sps off
raw 211:*:{
  if ($5 !isnum) { halt }
  inc %portcount | if (%portcount < 2) { halt }
  %servp.tmp = $5 + $7 | set %servp.2 yes | inc %servp 1 | if ($chr(46) isin $left($right($2,5),4)) { %servp = %servp - 1 | halt }
  if ($dialog(sportscan) != $null) { did -a sportscan 4 $left($right($2,5),4) - $chr(40) $+ %servp.tmp KB $+ $chr(41) }
  if %servp.psc == $null { %servp.best =  $left($right($2,5),4) | %servp.bp = $5 + $7 | set %servp.psc active }
  else { %servp.tp = $5 + $7 | if (%servp.tp < %servp.bp) { %servp.best = $left($right($2,5),4) | %servp.bp = $5 + $7 } | unset %servp.tp }
  halt
}
raw 219:*:{
  if ($2 == l) {
    if (%servp.2 == $null) { if ($dialog(sportscan) != $null) { did -o sportscan 6 1 This server restricts sportscan | goto end } }
    if ($dialog(sportscan) != $null) {
      if ($dialog(sportscan) != $null) { if (%servp == $null) { did -o sportscan 6 1 There is no port list } | if (%servp = 1) { did -o sportscan 6 1 Found %servp Port } }
      if ($dialog(sportscan) != $null) { if (%servp > 1) { did -o sportscan 6 1 Found %servp Ports } }
      goto end
    }
    :end 
    if ($dialog(sportscan) != $null) { did -e sportscan 1 | did -o sportscan 14 1 %servp.best }
    .disable #sps | unset %servp.* 
    if ($dialog(sportscan) != $null) { did -z sportscan 4 }
    halt
  }
}
#sps end
on *:disconnect:{
  if ($dialog(sportscan)) {
    if ($dialog(sportscan) != $null) { did -o sportscan 6 1 Not connected to server | did -b sportscan 1 | did -b sportscan 4 | did -r sportscan 2 | did -r sportscan 8 | did -r sportscan 14 }
  }
}
on *:connect:{
  if ($_vr(sportscan,connect) == on) && ($dialog(sportscan) == $null) { sportscan }
  if ($dialog(sportscan) != $null) {
    if ($dialog(sportscan) != $null) {
      did -e sportscan 1 | did -e sportscan 4 | did -o sportscan 2 1 $server | did -o sportscan 8 1 $port
      did -r sportscan 6 | did -o sportscan 6 1 Connected
    }
  }
}
alias ae return echo -a
alias se return echo -s
;[read write data/setting.ini]
alias _vr {
  if ($exists(data\setting.ini) == $false) { mkdir data | write -c data\setting.ini }
  return $readini data\setting.ini $1 $2 
}
alias _vw {
  if ($exists(data\setting.ini) == $false) { mkdir data | write -c data\setting.ini }
  writeini data\setting.ini $1 $2 $3-
}
